function redirect(o, w)
	return function(s)
		return stead.call(stead.ref(o), w)
	end
end

parser.ifobj = function(s, w)
	local k, o 
	local n
	for k,o in opairs(objs()) do
		if not isDisabled(o) then
			return w
		end
	end
	return
end
parser.directions = { 
	{"n", "север" };
	{"ne", "северо-восток"};
	{"e", "восток"};
	{"se", "юго-восток"};
	{"s", "юг"};
	{"sw", "юго-запад"};
	{"w", "запад"};
	{"nw","северо-запад"};
}

parser.events.Walk = function(s, w, ww, www)
	local k,v
	if ww then w = ww end
	for k,v in ipairs(s.directions) do
		if v[2] == w then
			local m = here()[v[1]..'_to']
			if type(m) == 'string' then
				return walk(m)
			else
				local r, v = stead.call(here(), v[1]..'_to')
				return r,v
			end
		end
	end
	return "Некуда идти."
end
local function mwalk(d)
	return function(s)
		local k,v
		if here()[d..'_to'] then
			for k,v in ipairs(s.directions) do
				if v[1] == d then
					return '~'..v[2]
				end
			end
		end
	end
end

local putany = function(s)
	if s:word(3) == 'на' then
		return 'Puton %2 %4'
	elseif s:word(3) == 'в' then
		return 'Putin %2 %4 | Receive %4 %2'
	else
		return 'Putunder %2 %4'
	end
end

local lookany = function(s)
	if s:word(2) == 'на' then
		return 'Lookat %3'
	elseif s:word(2) == 'в' then
		return 'Lookat %3'
	end
end

local lookobj = function(s)
	if s:word(2) == 'на' then
		return '{obj}вн|{inv}вн'
	elseif s:word(2) == 'в' then
		return '{obj}вн|{inv}вн'
	end
end

local searchany = function(s)
	if s:word(2) == 'на' then
		return 'Searchon %3'
	elseif s:word(2) == 'в' then
		return 'Search %3'
	else
		return 'Searchunder %3'
	end
end

local searchobj = function(s)
	if s:word(2) == 'на' then
		return '{obj}пр|{inv}пр'
	elseif s:word(2) == 'в' then
		return '{obj}пр|{inv}пр'
	else
		return '{obj}тв|{inv}тв'
	end
end

local pushobj = function(s)
	if s:word(3) == 'к'  then
		return "{obj}дт"
	elseif s:word(3) == 'на' then
		return "{obj}вн"
	end
end

game.verbs = {
	{ "Exam", "~осмотреться" },
	{"Inventory", "инвентарь" },
	{ "Exam %2", "осмотреть", "{obj}вн|{inv}вн|{iam}вн" },
	{ "Exam %2", "~изучить", "{obj}вн|{inv}вн" },
	{ "Exam %2", "~исследовать", "{obj}вн|{inv}вн" },

	{ "Lookat %3", "посмотреть", "на|в", "{obj}вн|{inv}вн" },
	{ "Lookat %3", "~смотреть", "на|в", "{obj}вн|{inv}вн" },

	{ searchany, "искать", "на|в|под", searchobj },
	{ 'Search %2', "~обыскать", "{obj}вн|{inv}вн" },

	{ "Open %2 %3|Openby %3 %2", "открыть", "{obj}вн|{inv}вн", "{}|{inv}тв" },
	{ "Close %2", "закрыть", "{obj}вн|{inv}вн" },
	
	{ "Push %2 %4|Moved %4 %2", "толкнуть", "{obj}вн", "{}|к|на", pushobj },
	{ "Push %2 %4|Moved %4 %2", "~двигать", "{obj}вн", "{}|к|на", pushobj },
	{ "Push %2 %4|Moved %4 %2", "~сдвинуть", "{obj}вн", "{}|к|на", pushobj },

	{ "Pull %2", "тянуть", "{obj}вн" },

	{ "Smell %2", "нюхать", "{obj}вн|{inv}вн" },
	{ "Smell %2", "~понюхать", "{obj}вн|{inv}вн" },

	{ "Eat %2", "есть", "{obj}вн|{inv}вн" },
	{ "Eat %2", "~съесть", "{obj}вн|{inv}вн" },

	{ "Putin %2 %4|Receive %4 %2", "вставить", "{inv}вн", "в", "{obj}вн|{inv}вн"},
	{ "Putin %2 %4|Receive %4 %2", "~воткнуть", "{inv}вн", "в", "{obj}вн|{inv}вн"},

	{ putany, "поставить", "{inv}вн", "на|в|под", "{obj}вн|{inv}вн"},
	{ putany, "~положить", "{inv}вн", "на|в|под", "{obj}вн|{inv}вн"},

	{ "Attack %2 %3", "ударить", "{obj}вн", "{}|{inv}тв"},
	{ "Attack %2 %3" , "~бить", "{obj}вн", "{}|{inv}тв" },
	{ "Attack %2 %3", "~разбить", "{obj}вн", "{}|{inv}тв" },
	{ "Attack %2 %3", "~сломать", "{obj}вн", "{}|{inv}тв" },


	{ "Walk %2 %3", "идти", function(s)
		local rc = ''
		if here().n_to or here().ne_to or here().e_to or here().se_to or here().s_to or here().sw_to or here().w_to or here().nw_to then
			rc = 'на|'
		end
		if here().up_to then
			rc = rc..'наверх|'
		end
		if here().down_to then
			rc = rc..'вниз|'
		end
		if #ways() ~= 0 then
			rc = rc..'{way}'
		end
		return rc
	end, function(s)
		local k, v
		local rc = ''
		for k, v in ipairs(s.directions) do
			if here()[v[1].."_to"] then
				rc = rc..v[2]..'|'
			end
		end
		return rc
	end	 };
	{ "Walk %1", mwalk 'n' };
	{ "Walk %1", mwalk 'ne' };
	{ "Walk %1", mwalk 'e' };
	{ "Walk %1", mwalk 'se' };
	{ "Walk %1", mwalk 's' };
	{ "Walk %1", mwalk 'sw' };
	{ "Walk %1", mwalk 'w' };
	{ "Walk %1", mwalk 'nw' };
	
	{ "Take %2", "взять", "{obj}вн" },
	{ "Take %2", "~забрать", "{obj}вн" },
	{ function(s)
		if s:word(3) == 'в' then
			return "Drop %2 %4 | Receive %4 %2"
		else
			return "Drop %2 %4"
		end
	end, "бросить", "{inv}вн", function()
			return parser:ifobj('{}|в|на')
		end,"{obj} вн"},
	{ "Drop %2","~выбросить", "{inv}вн" },
	{ "Remove %2 %3", "извлечь", "{obj}вн", "{}|{inv}тв"},
	{ "Remove %2 %3", "~вытащить", "{obj}вн", "{}|{inv}тв"}
};

parser.it = function(s, w, nm)
	local rc, n, v

	nm = morph:case2n(nm)

	local a1 = {'он', 'его', 'ему', 'его', 'им', 'нем' };
	local a2 = {'оно', 'его', 'ему', 'его', 'им', 'нем' };
	local a3 = {'она', 'её', 'ей', 'ее', 'ней', 'ней' };
	local a4 = { 'они', 'их', 'им', 'их', 'ими', 'них' };
	
	rc = parser:gender(w)
	if rc.plural then
		v = a4
	elseif rc.male then
		v = a1
	elseif rc.female then
		v = a3
	else
		v = a2
	end
	return v[nm]
end

parser.need = function(s, w)
	local rc
	rc = parser:gender(w)
	if rc.plural then
		return "нужны"
	elseif rc.male then
		return "нужен"
	elseif rc.female then
		return "нужна"
	else
		return "нужно"
	end
end

parser.events.before_Exam = function(self, s)
	if not s then
		stead.need_scene()
		return true
	end
end

parser.events.after_Exam = function(self, s)
	local w = s
	p ("Ты осмотрел ", w:M 'вн', " и не нашел в ", w:it 'пр', " ничего необычного.");
	return
end;

parser.events.Inventory = function(self, s)
	local k,v
	local n = 0
	local m = 0
	local rc = 0
	for k,v in opairs(inv()) do
		if v ~= parser_menu_items and not v.hidden and not isDisabled(o) then
			n = n + 1
		end
	end
	if n == 0 then return "У тебя с собой ничего нет." end
	if n <= 2 then rc =  "У тебя с собой только " else
		rc = "У тебя с собой: "
	end

	for k,v in opairs(inv()) do
		if v ~= parser_menu_items and not v.hidden and not isDisabled(v) then
			rc = rc .. v:M(); --stead.dispof(v)
			m = m + 1
			if m == n then
				rc = rc..'.'
			elseif m == n - 1 then
				rc = rc..' и ';
			else
				rc = rc..','
			end
		end
	end
	return rc
end

parser.events.Drop = function(self, s, w)
	if not s.dropable then
		local rc = s:G()
		if rc.singular then
			rc = 'может'
		else
			rc = 'могут'
		end
		p ("Тебе ", s:it 'им', ' еще '..rc..' пригодиться.');
		return
	end
	if not w then
		return "Куда?"
	end
	drop(s)
	return r, v
end

parser.events.after_Drop = function(self, s, w, t)
	p ("Ты выбросил ",s:M 'вн',".")
end


parser.events.Take = function(self, s)
	if not s.takeable then
		p ("Тебе не ", parser:need(s), " ", s:M 'им', ".")
		return false
	end
	take(s)
end;

parser.events.after_Take = function(self, s)
	p ("Ты забрал ", s:M 'вн', ".");
end;

parser.gensw = function(s, w, a, b, c, d, e, f)
	local rc = parser:gender(w)
	if rc.male then
		if rc.singular then
			rc = a
		else
			rc = d;
		end
	elseif rc.female then
		if rc.singular then
			rc = b;
		else
			rc = e
		end
	else
		if rc.singular then
			rc = c;
		else
			rc = f
		end
	end
	return rc
end

parser.events.Open = function(self, s, w)
	if s.openable then
		if s.opened then
			local rc = parser:gensw(s, "открыт", "открыта", "открыто", "открыты", "открыты", "открыты")
			p (parser:cap(s:M 'им'), " уже ", rc, ".");
			return
		end
		if w then
			return "Может, сделать это проще?"
		end
	else
		p (parser:cap(s:M 'вн'), " нельзя открыть.");
		return
	end
	s.opened = true;
end

parser.events.after_Open = function(self, s)
	p ("Ты открыл ", s:M 'вн', ".");
	s:enable_all()
end;

parser.events.Close = function(self, s)
	if s.openable then
		if not s.opened then
			local rc = parser:gensw(s, "закрыт", "закрыта", "закрыто", "закрыты", "закрыты", "закрыты")
			p (parser:cap(s:M 'им'), " уже ", rc, ".");
			return
		end
		s.opened = false
	else
		p (parser:cap(s:M 'вн'), " нельзя закрыть.");
	end
end;

parser.events.after_Close = function(self, s)
	p ("Ты закрыл ", s:M 'вн', ".");
	s:disable_all()
end;

parser.events.after_Push = function(self, s, w)
	p ([[Нет смысла двигать ]], s:M 'вн', '.')
end

parser.events.after_Pull = function(self, s, w)
	p ([[Нет смысла тянуть ]], s:M 'вн', '.')
end

parser.events.after_Attack = function(self, s, w)
	p ([[Агрессия к ]],  s:M 'дт', [[ не оправдана.]])
	return
end

parser.events.after_Lookat = function(self, s, ...)
	parser.redirect = { { "Exam", s, ... } }
	return true 
end

parser.events.after_Search = function(self, s, w)
	p ([[Ты обыскал ]],  s:M 'вн', [[, но ничего не нашел.]])
	return
end
parser.events.after_Searchon = parser.events.after_Search
parser.events.after_Searchunder = parser.events.after_Search

parser.events.after_Smell = function(self, s)
	p ([[Ты понюхал ]],  s:M 'вн', [[. Пахнет как ]], s:M 'им', '.')
end

parser.events.Remove = function(self, s, w)
	if not w and s.takeable then
		take(s)
		return
	end
	if not s.removable then
		p (self:cap(s:M 'вн')..' нельзя извлечь.')
		p ('Тем более '..s:M 'тв'..'.')
		return
	end
	if not w then
		p "Как именно это сделать?"
		return
	end
	if not have(w) then
		p ("У тебя нет "..w:M 'рд'..'.')
		return
	end
	take(s)
end

parser.events.after_Remove = function(self, s, w)
	if w then
		p ("Ты извлек "..s:M 'вн'.." при помощи "..w:M 'рд'..'.')
		return
	end
	p ("Ты взял "..s:M 'вн');
end

parser.events.Eat = function(self, s)
	if not s.eatable then
		p ("Тебе не хочется есть "..s:M 'вн')
		return
	end
	inv():del(s)
end

parser.events.after_Eat = function(self, s)
	p ([[Ты съел ]],  s:M 'вн', [[.]])
end

parser.events.Putin = function(self, s, w)
	if not s.dropable then
		p (parser:cap(s:M 'им')..' еще может пригодиться.')
		return
	end

	if not w then
		p "Куда?"
		return
	end
	if w.container and ( not w.openable or w.opened) then
		put(s, w)
	else
		p("Невозможно поместить "..s:M 'вн'..' в '..w:M 'вн'..'.')
	end
	return r, v
end

parser.events.Puton = parser.events.Putin
parser.events.Putunder = parser.events.Putin

parser.events.after_Putin = function(self, s, w)
	p ([[Ты положил ]].. (s:M 'вн')..' в '..(w:M 'вн')..'.')
end

parser.events.after_Puton = function(self, s, w)
	p ([[Ты положил ]].. (s:M 'вн')..' на '..(w:M 'вн')..'.')
end

parser.events.after_Puton = function(self, s, w)
	p ([[Ты положил ]].. (s:M 'вн')..' под '..(w:M 'вн')..'.')
end

local function fill_aliases(b, s)
	local k,v
	local base, before_base, after_base
	for k,v in ipairs(b) do
		if not base then
			base = s[v]
			before_base = s['before_'..v]
			after_base = s['after_'..v]
		else
			s[v] = base
			s['before_'..v] = before_base
			s['after_'..v] = after_base
		end
	end
end

obj = stead.inherit(obj, function(v)
	local a,b
	local const = {}
	local new_attr = {};

	for a, b in pairs(v) do
		if type(a) == 'number' and type(b) == 'table' then
			if b.construct_type then
				stead.table.insert(const, b)
			end
		end
	end
	for a, b in pairs(parser.attrs) do
		if v[a] == nil then
			new_attr[a] = b
		end
	end
	stead.add_var(v, new_attr)

	for a, b in ipairs(const) do
		b:constructor(v)
	end

	if not v.opened then
		stead.add_var(v, { opened = false; })
	end

	v.it = function(s, w)
		return parser:it(s, w)
	end
	v.G = function(s)
		return parser:gender(s)
	end
	v.M = function(s, w)
		if not w then w = 'им' end
		local a = parser:morph(s, w)
		local ww
		if type(a) == 'string' then
			a:gsub("[^~|]+", function(s)
				if not ww then
					ww = s
				end
			end)
		end
		if ww then
			return ww
		end
		return a
	end
	v.menu_type = true
	return v
end)

function alias(t)
	local v = { }
	v.construct_type = true
	if type(t) ~= 'string' then
		error("Wrong aliase.", 2)
	end
	t:gsub("[^:, \t]+", function(s)
		local a = s
		stead.table.insert(v, a)
	end)
	v.constructor = fill_aliases;
	return v
end

function attr(t)
	local v = { }
	if type(t) ~= 'string' then
		error("Wrong attr.", 2)
	end
	t:gsub("[^, \t]+", function(s)
		local a = s:gsub("^~", "")
		if s:find("^~") then
			v[a] = false
		else
			v[a] = true
		end
	end)
	return var(v)
end

parser.attrs = {}

function Attribute(t)
	if type(t) ~= 'string' then
		error("Wrong attr.", 2)
	end
	t:gsub("[^, \t]+", function(s)
		local a = s:gsub("^~", "")
		if s:find("^~") then
			parser.attrs[a] = false
		else
			parser.attrs[b] = true
		end
	end)
end

local function parse_header(s)
	local l,r, exp
	local v = {}
	if not s:find(":", 1, true) then
		l = s
	else
		l = s:gsub("^([^:]+):.*$", "%1")
		r = s:gsub("^[^:]+:(.*)$", "%1")
	end
	l:gsub("[^ ,]+", function(s)
		stead.table.insert(v, s)
	end)
	v.expr = r
	return v
end
-- trigger [[tafter_adds():
-- after [[action,asdfs():
function trigger(t)
	local v = { }
	if type(t) ~= 'string' then
		error("Wrong trigger.", 2)
	end
	t:gsub("[^:, \t]+", function(s)
	end)
	return var(v)
end

local function musthave_checker(v)
	return function(s, ...)
		if not have(s) then
			if s.no_have_msg then
				p(s.no_have_msg)
			else
				p ([[Сначала нужно взять ]]..s:M 'вн'..'.')
			end
		end
	end
end

function musthave(t)
	if type(t) ~= 'string' then
		error("Wrong musthave argument.", 2)
	end
	local v = parse_header(t)
	v.construct_type = true
	v.constructor = function(o, s)
		local k, v
		for k,v in ipairs(o) do
			s[v] = musthave_checker(v)
		end
		s.no_have_msg = o.expr
	end
	return v
end

function Verb(s)
	if type(s) ~= 'table' then
		error ("Wrong Verb.", 2)
	end
	stead.table.insert(game.verbs, s)
end
